"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FrontMatterComponent = void 0;
const reflection_title_1 = require("typedoc-plugin-markdown/dist/resources/helpers/reflection-title");
const components_1 = require("typedoc/dist/lib/converter/components");
const components_2 = require("typedoc/dist/lib/output/components");
const events_1 = require("typedoc/dist/lib/output/events");
let FrontMatterComponent = class FrontMatterComponent extends components_2.RendererComponent {
    initialize() {
        super.initialize();
        this.listenTo(this.application.renderer, {
            [events_1.PageEvent.END]: this.onPageEnd,
        });
    }
    onPageEnd(page) {
        if (page.contents) {
            page.contents = page.contents
                .replace(/^/, this.getYamlString(this.getYamlItems(page)) + '\n\n')
                .replace(/[\r\n]{3,}/g, '\n\n');
        }
    }
    getYamlString(yamlItems) {
        const yaml = `---
${Object.entries(yamlItems)
            .map(([key, value]) => `${key}: ${typeof value === 'string' ? `"${this.escapeYAMLString(value)}"` : value}`)
            .join('\n')}
---`;
        return yaml;
    }
    getYamlItems(page) {
        const pageTitle = this.getTitle(page);
        return {
            title: pageTitle,
        };
    }
    getTitle(page) {
        return reflection_title_1.reflectionTitle.call(page, false);
    }
    escapeYAMLString(str) {
        return str.replace(/([^\\])'/g, '$1\\\'').replace(/\"/g, '');
    }
};
FrontMatterComponent = __decorate([
    components_1.Component({ name: 'front-matter' })
], FrontMatterComponent);
exports.FrontMatterComponent = FrontMatterComponent;
